PLaSK library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
plask::PointsOnCircleMeshExtend Struct Reference

3D mesh that wrap 2D mesh (sourceMesh). More...

`#include <plask/mesh/transformed.hpp>`

Inheritance diagram for plask::PointsOnCircleMeshExtend:
[legend]
Collaboration diagram for plask::PointsOnCircleMeshExtend:
[legend]

## Public Types
enum | { SRC_DIM = 2 }
| Number of source dimensions. More...
typedef Geometry2DCylindrical | SourceGeometry
| Source geometry.
typedef Geometry3D | TargetGeometry
| Target geometry.
Public Types inherited from plask::MeshD< 3 >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator

## Public Member Functions
Vec< 3, double > | getCenterForPoint (const Vec< 2, double > &p) const
| PointsOnCircleMeshExtend (const shared_ptr< const MeshD< 2 > > &sourceMesh, const Vec< 3, double > &translation=Primitive< 3 >::ZERO_VEC, std::size_t pointsCount=18)
Vec< 3, double > | at (std::size_t index) const override
| Get point with given mesh index.
std::size_t | size () const override
Vec< 3, double > | rVector (std::size_t index) const
Public Member Functions inherited from plask::MeshD< 3 >
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual bool | empty () const
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Public Attributes
const shared_ptr< const MeshD< 2 > > | sourceMesh
Vec< 3, double > | translation
double | slice
std::size_t | pointsCount
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.

## Additional Inherited Members
Protected Member Functions inherited from plask::MeshD< 3 >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

3D mesh that wrap 2D mesh (sourceMesh).

Each point from sourceMesh is replaced by pointsCount points that lie on circle. Point with index I in sourceMesh is used to creates points I * pointsCount to I * (pointsCount + 1) - 1.

Definition at line 175 of file transformed.hpp.

## Member Typedef Documentation

## ◆ SourceGeometry

typedef Geometry2DCylindrical plask::PointsOnCircleMeshExtend::SourceGeometry

Source geometry.

Definition at line 192 of file transformed.hpp.

## ◆ TargetGeometry

typedef Geometry3D plask::PointsOnCircleMeshExtend::TargetGeometry

Target geometry.

Definition at line 195 of file transformed.hpp.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Number of source dimensions.

Enumerator
SRC_DIM |

Definition at line 198 of file transformed.hpp.

## Constructor & Destructor Documentation

## ◆ PointsOnCircleMeshExtend()

plask::PointsOnCircleMeshExtend::PointsOnCircleMeshExtend | ( | const shared_ptr< const MeshD< 2 > > & | sourceMesh,
|  | const Vec< 3, double > & | translation = `Primitive<3>::ZERO_VEC`,
|  | std::size_t | pointsCount = `18`
| ) |  |
| inline

Definition at line 200 of file transformed.hpp.

## Member Function Documentation

## ◆ at()

Vec< 3, double > plask::PointsOnCircleMeshExtend::at | ( | std::size_t | index | ) | const
| inline override virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< 3 >.

Definition at line 204 of file transformed.hpp.

## ◆ getCenterForPoint()

Vec< 3, double > plask::PointsOnCircleMeshExtend::getCenterForPoint | ( | const Vec< 2, double > & | p | ) | const
| inline

Definition at line 185 of file transformed.hpp.

## ◆ rVector()

Vec< 3, double > plask::PointsOnCircleMeshExtend::rVector | ( | std::size_t | index | ) | const
| inline

Definition at line 218 of file transformed.hpp.

## ◆ size()

std::size_t plask::PointsOnCircleMeshExtend::size | ( |  | ) | const
| inline override virtual

Returns
  number of points in mesh

Implements plask::Mesh.

Definition at line 214 of file transformed.hpp.

## Member Data Documentation

## ◆ pointsCount

std::size_t plask::PointsOnCircleMeshExtend::pointsCount

Definition at line 183 of file transformed.hpp.

## ◆ slice

double plask::PointsOnCircleMeshExtend::slice

Definition at line 181 of file transformed.hpp.

## ◆ sourceMesh

const shared_ptr<const MeshD<2> > plask::PointsOnCircleMeshExtend::sourceMesh

Definition at line 177 of file transformed.hpp.

## ◆ translation

Vec<3,double> plask::PointsOnCircleMeshExtend::translation

Definition at line 179 of file transformed.hpp.

The documentation for this struct was generated from the following file:

- plask/mesh/transformed.hpp